{#- For libraries #}

#include <stdint.h>

#include "network/rescaling.hpp"

// Custom headers
{%- for header in headers %}
#include "{{ header }}"
{%- endfor %}

static {{input_t}} mem[MEMORY_SIZE];

{# Forward function #}
/* Top Level */
#pragma hls_design interface
{# model_forward is called propagate in the original design #}
void CCS_BLOCK(model_forward)(ac_sync &start, const {{input_t}}* {{inputs}}, {{output_t}}* {{outputs}})
{
    {% for action in actions %}
    {{ action }}
    {%- endfor %}
}

private:
    mem_in<{{name|upper}}_NB_CHANNELS,
            {{name|upper}}_CHANNELS_HEIGHT,
            {{name|upper}}_CHANNELS_WIDTH,
            {{name|upper}}_OUTPUTS_HEIGHT,
            {{name|upper}}_OUTPUTS_WIDTH,
            {{name|upper}}_PADDING_Y,
            {{name|upper}}_PADDING_X,
            {{name|upper}}_STRIDE_Y,
            {{name|upper}}_STRIDE_X,
            {{name|upper}}_KERNEL_HEIGHT,
            {{name|upper}}_KERNEL_WIDTH,
            {{name|upper}}_ACTIVATION,
            DATA_T,
            {{child_name|upper}}_in_t> {# it's the name of the next layer not the current one #}
            mem_in_inst;

    {# Need to add all transitions between layers below #}
    
